# -*- coding: utf-8 -*-
# Generated by Django 1.9.9 on 2016-09-07 23:11
from __future__ import unicode_literals

import django.contrib.auth.models
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
import django_sharding_library.fields
import django_sharding_library.id_generation_strategies
import tests.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('auth', '0007_alter_validators_add_error_messages'),
    ]

    operations = [
        migrations.CreateModel(
            name='User',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('password', models.CharField(max_length=128, verbose_name='password')),
                ('last_login', models.DateTimeField(blank=True, null=True, verbose_name='last login')),
                ('is_superuser', models.BooleanField(default=False, help_text='Designates that this user has all permissions without explicitly assigning them.', verbose_name='superuser status')),
                ('username', models.CharField(error_messages={'unique': 'A user with that username already exists.'}, help_text='Required. 30 characters or fewer. Letters, digits and @/./+/-/_ only.', max_length=30, unique=True, validators=[django.core.validators.RegexValidator('^[\\w.@+-]+$', 'Enter a valid username. This value may contain only letters, numbers and @/./+/-/_ characters.')], verbose_name='username')),
                ('first_name', models.CharField(blank=True, max_length=30, verbose_name='first name')),
                ('last_name', models.CharField(blank=True, max_length=30, verbose_name='last name')),
                ('email', models.EmailField(blank=True, max_length=254, verbose_name='email address')),
                ('is_staff', models.BooleanField(default=False, help_text='Designates whether the user can log into this admin site.', verbose_name='staff status')),
                ('is_active', models.BooleanField(default=True, help_text='Designates whether this user should be treated as active. Unselect this instead of deleting accounts.', verbose_name='active')),
                ('date_joined', models.DateTimeField(default=django.utils.timezone.now, verbose_name='date joined')),
                ('shard', models.CharField(blank=True, choices=[(b'app_shard_001', b'app_shard_001'), (b'app_shard_002', b'app_shard_002')], max_length=120, null=True)),
                ('groups', models.ManyToManyField(blank=True, help_text='The groups this user belongs to. A user will get all permissions granted to each of their groups.', related_name='user_set', related_query_name='user', to='auth.Group', verbose_name='groups')),
                ('user_permissions', models.ManyToManyField(blank=True, help_text='Specific permissions for this user.', related_name='user_set', related_query_name='user', to='auth.Permission', verbose_name='user permissions')),
            ],
            options={
                'abstract': False,
                'verbose_name': 'user',
                'verbose_name_plural': 'users',
            },
            managers=[
                ('objects', django.contrib.auth.models.UserManager()),
            ],
        ),
        migrations.CreateModel(
            name='PostgresCustomIDModel',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('random_string', models.CharField(max_length=120)),
                ('user_pk', models.PositiveIntegerField()),
            ],
        ),
        migrations.CreateModel(
            name='ShardedByForiegnKeyModel',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('random_string', models.CharField(max_length=120)),
            ],
        ),
        migrations.CreateModel(
            name='ShardedModelIDs',
            fields=[
                ('id', django_sharding_library.fields.BigAutoField(primary_key=True, serialize=False)),
                ('stub', models.NullBooleanField(default=True, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ShardedTestModelIDs',
            fields=[
                ('id', django_sharding_library.fields.BigAutoField(primary_key=True, serialize=False)),
                ('stub', models.NullBooleanField(default=True, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ShardStorageTable',
            fields=[
                ('shard', models.CharField(choices=[(b'app_shard_001', b'app_shard_001'), (b'app_shard_002', b'app_shard_002')], max_length=120)),
                ('shard_key', models.CharField(max_length=120, primary_key=True, serialize=False)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TestModel',
            fields=[
                ('id', django_sharding_library.fields.TableShardedIDField(primary_key=True, serialize=False, source_table=tests.models.ShardedTestModelIDs, strategy=django_sharding_library.id_generation_strategies.TableStrategy(backing_model=tests.models.ShardedTestModelIDs))),
                ('random_string', models.CharField(max_length=120)),
                ('user_pk', models.PositiveIntegerField()),
            ],
        ),
        migrations.CreateModel(
            name='UnshardedTestModel',
            fields=[
                ('id', django_sharding_library.fields.TableShardedIDField(primary_key=True, serialize=False, source_table=tests.models.ShardedTestModelIDs, strategy=django_sharding_library.id_generation_strategies.TableStrategy(backing_model=tests.models.ShardedTestModelIDs))),
                ('random_string', models.CharField(max_length=120)),
                ('user_pk', models.PositiveIntegerField()),
            ],
        ),
        migrations.AddField(
            model_name='shardedbyforiegnkeymodel',
            name='shard',
            field=django_sharding_library.fields.ShardForeignKeyStorageField(on_delete=django.db.models.deletion.CASCADE, shard_group=b'default', to='tests.ShardStorageTable'),
        ),
        migrations.AddField(
            model_name='shardedbyforiegnkeymodel',
            name='test',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='tests.UnshardedTestModel'),
        ),
    ]
